Subject: Re: [patch 3/6] Walnut DTS

From: Josh Boyer <[email-masked]>
Date: Tue, 04 Sep 2007 19:39:26 -0500

On Wed, 2007-09-05 at 12:36 +1000, David Gibson wrote:
> On Tue, Sep 04, 2007 at 07:42:03AM -0500, Josh Boyer wrote:
> > On Sun, 02 Sep 2007 08:59:44 -0500
> > Josh Boyer <[email-masked]> wrote:
> [snip]
> > > > > +		POB0: opb {
> > > > > +			compatible = "ibm,opb";
> > > > 
> > > > Need an opb-405gp here, too.
> > > 
> > > Yep.
> > 
> > Fixed.
> > 
> > > > > +			#address-cells = <1>;
> > > > > +			#size-cells = <1>;
> > > > > +			ranges = <0 ef600000 a00000>;
> > > > 
> > > > Hrm... something we ought to clarify is the interpretation of the
> > > > POB0_BEAR register with respect to the bridge's ranges property.  For
> > > > 440 I think the BEAR will need to be interpreted as an OPB address,
> > > > rather than a PLB address, but I'm not sure if that will work here
> > > > with the limited ranges property you have.
> > > 
> > > Ok, I'll look at this.
> > 
> > The BEAR will still be interpreted as a PLB address here as far as I
> > can see.  The ranges spans the entire OPB space.  Am I missing
> > something?
> 
> Ah, sorry, my mistake.  I thought the BEAR register would encode an
> OPB address rather than a PLB address (and thus, be only 32-bits wide
> on 440).  In fact it appears it does encode a PLB address (and is
> split into BEARH and BEARL registers on 440).

Right.

> Hrm.. I'm still slightly uneasy though.  In my Ebony device tree, the
> POB's ranges exists to embed the 32-bit OPB space into the 64-bit PLB
> space by tacking on a 0x1 in bits 32:35.  In your 405gp ranges, you're
> describing just the address range used by OPB peripherals
> (0xef600000-0xf0000000) as residing at address 0 in OPB-space.
> 
> Since the ranges will still generate the right physical addresses, I
> guess it doesn't matter.  But I'm not sure it meets the principle of
> least surprise - since I think the documentation generally talks as
> though addresses on the 405 OPB bus are identical to addreses on the
> PLB.

I don't care either way.  If I remember correctly, this way of doing it
came out of a discussion with Segher.

josh